from time import sleep
from pyjuni.uglybot import *
from pyjuni.jkeyevent import *

leftir = 0
midir = 0
rightir = 0
preState = 0

def receiveData(packet):
    global leftir    # 글로벌 변수 사용
    global midir     # 글로벌 변수 사용
    global rightir   # 글로벌 변수 사용
    leftir = packet[8];   # 패킷 8번 자리에 좌측 근접센서값이 들어감
    midir = packet[9];    # 패킷 9번 자리에 중간 근접센서값이 들어감
    rightir = packet[10]; # 패킷 10번 자리에 우측 근접센서값이 들어감


if __name__ == '__main__': 
    uglybot = UglyBot(receiveData)
    jkey = JKeyEvent()    
    uglybot.Open()

    lineRef = 60
    uglybot.ir(7)  # IR 센서 모두 켜기
    while not jkey.isKeyEscPressed(): # ESC 키 눌렀을 때까지 루프
        leftMotor = 20    #  왼쪽모터 세기.  값이 클수록 속도는 빨라지나 탈선 가능성이 높아짐
        rightMotor = 20   #  오른쪽모터 세기. 값이 클수록 속도는 빨라지나 탈선 가능성이 높아짐
        if leftir < lineRef :      # 만약 왼쪽 센서값이 lineRef 미만일 경우 (오른쪽 치우침) 
            leftMotor -= 10  # 왼쪽 모터 회전 속도 줄임.
            preState = 1     # 이전상태 값 '1'로 정의
        elif rightir < lineRef :   # 만약 오른쪽 센서 값이 lineRef 미만일 경우(왼쪽 치우침)
            rightMotor -= 10 # 오른쪽 모터 회전 속도 줄임
            preState = 2     # 이전상태 값 '2'로 정의  
        elif midir < lineRef :     # 만약 중간 센서 값이 lineRef 미만 일 경우(치우침 없음)
            preState = 0     #  이전상태 값 '0'로 정의
        if leftir>lineRef  and midir>lineRef  and rightir>lineRef :  # 왼쪽,중간, 오른쪽 센서 lineRef 이상일 경우 (탈선 상태)
            if preState == 1:  # 만약 이전상태 값이 '1'일 경우 오른쪽 치우침으로 판단됨
                leftMotor = 0  # 왼쪽 모터 세기 '0'으로 설정해 왼쪽으로 돌아가게 함
            if preState == 2:   # 만약 이전상태 값이 '2'일 경우 오른쪽 치우침으로 판단됨
                rightMotor = 0 # 오른쪽 모터 세기 '0'으로 정의해 오른쪽으로 돌아가게 함
        uglybot.motor(leftMotor, rightMotor)   # 모터 함수 호출
        sleep(0.05)

    uglybot.Close()
